local function_overrides = {
	{ "_get_tweak_data_weapon_animation", false },
	{ "ammo_base", false },
	{ "fire_mode", false },
	{ "can_toggle_firemode", false },
	{ "reload_prefix", false },
	{ "is_single_shot", false },

	{ "start_shooting_allowed", false },
	{ "_spawn_muzzle_effect", false },
	{ "_spawn_shell_eject_effect", false },
	{ "_fire_raycast", true },
	{ "_get_sound_event", true },

	{ "reload_speed_stat", false }
}

local function setupUnderbarrelOverrides( object )
	for i, function_table in ipairs(function_overrides) do
		local function_name = function_table[1]
		local use_weapon_base = function_table[2]

		if object[function_name] then
			object[function_name .. "_backup"] = object[function_name]

			object[function_name] = function( self, ... )
				if self:gadget_overrides_weapon_functions() then
					if use_weapon_base then
						return self:gadget_function_override( function_name, self, ... )
					else
						return self:gadget_function_override( function_name, ... )
					end
				else
					return self[function_name .. "_backup"](self, ... )
				end
			end
		end
	end
end

Hooks:PostHook( RaycastWeaponBase, "init", "WeaponBaseFunctionOverrides", function(self, unit) 
	setupUnderbarrelOverrides( self )
end)