Hooks:PostHook( BlackMarketGui, "_setup", "UnderbarrelWeaponsBaseBlackMarketGUISetup", function(self, is_start_page, component_data)
	self._btns.wm_weapontweakdata_switch_menu = deep_clone(self._btns.wm_reticle_switch_menu)
	self._btns.wm_weapontweakdata_switch_menu._btn_text_id = "bm_menu_btn_switch_weapontweakdata"
end)

Hooks:PostHook( BlackMarketGui, "populate_mods", "UnderbarrelWeaponsBaseBlackMarketPopulateMods", function(self, data)
	local crafted = managers.blackmarket:get_crafted_category(data.prev_node_data.category)[data.prev_node_data.slot]
	local global_values = crafted.global_values or {}

	local weapon_blueprint = managers.blackmarket:get_weapon_blueprint(data.prev_node_data.category, data.prev_node_data.slot) or {}
	local equipped = nil

	for i, mod in ipairs(data) do
		for _, weapon_mod in ipairs(weapon_blueprint) do
			if mod.name == weapon_mod and (not global_values[weapon_mod] or global_values[weapon_mod] == data[i].global_value) then
				equipped = i
				break
			end
		end
	end

	if equipped then
		local factory = tweak_data.weapon.factory.parts[data[equipped].name]

		if factory and factory.weapontweakdata_switch then
			if not crafted.customize_locked then
				table.insert(data[equipped], "wm_weapontweakdata_switch_menu")
			end

			data[equipped].weapontweakdata_switch = factory.weapontweakdata_switch

			--local reticle_texture = managers.blackmarket:get_part_texture_switch(data[equipped].category, data[equipped].slot, data[equipped].name)

			--if reticle_texture and reticle_texture ~= "" then
			--	data[equipped].mini_icons = data[equipped].mini_icons or {}

			--	table.insert(data[equipped].mini_icons, {
			--		layer = 2,
			--		h = 30,
			--		stream = true,
			--		w = 30,
			--		blend_mode = "add",
			--		bottom = 1,
			--		right = 1,
			--		texture = reticle_texture
			--	})
			--end
		end
	end
end )