MenuNodeReticleSwitchGui.old_init = MenuNodeReticleSwitchGui.init

function MenuNodeReticleSwitchGui:init(node, layer, parameters)
	local data = node:parameters().menu_component_data

	if tweak_data.weapon.factory.parts[data.name] and tweak_data.weapon.factory.parts[data.name].weapontweakdata_switch then
		self:tweakdata_init(node, layer, parameters)
	else
		self:old_init(node, layer, parameters)
	end
end

function MenuNodeReticleSwitchGui:tweakdata_init(node, layer, parameters)
	local data = node:parameters().menu_component_data
	local menu_items = node:items()
	local ammo_type = node:items()[1]
	local ammo_variant = node:items()[2]

	ammo_type:parameters().text_id = "menu_ammunition_type"
	ammo_variant:parameters().text_id = "menu_ammunition_variant"

	ammo_type:clear_options()
	--ammo_variant:clear_options()

	local weapontweakdata_switch = data.weapontweakdata_switch

	local types = {}
	for id, a_type in pairs(weapontweakdata_switch.types) do
		if a_type._meta == "type" and a_type.id then 
			types[a_type.id] = a_type
		end
	end

	for id, a_type in pairs(types) do
		log(id)
		ammo_type:add_option(CoreMenuItemOption.ItemOption:new({
			text_id = a_type.name_id or ("menu_" .. id),
			value = id
		}))
	end

	ammo_type:visible()
	--ammo_variant:visible()

	parameters.font = tweak_data.menu.pd2_small_font
	parameters.font_size = tweak_data.menu.pd2_small_font_size
	parameters.align = "left"
	parameters.row_item_blend_mode = "add"
	parameters.row_item_color = tweak_data.screen_colors.button_stage_3
	parameters.row_item_hightlight_color = tweak_data.screen_colors.button_stage_2
	parameters.marker_alpha = 1
	parameters.to_upper = true

	MenuNodeReticleSwitchGui.super.init(self, node, layer, parameters)
	--self:tweakdata_setup(node)
end

function MenuNodeReticleSwitchGui:tweakdata_setup(node)
	local color = node:item("reticle_color"):value()
	local type = node:item("reticle_type"):value()
	local data = node:parameters().menu_component_data
	local part_id = data.name
	local data_string = tostring(color) .. " " .. tostring(type)
	local texture = managers.blackmarket:get_texture_switch_from_data(data_string, part_id)

	self:set_reticle_texture(texture)
end